angular.module('app.service', [])

.factory('Item', function($resource) {
    var items = angular.fromJson(window.localStorage.getItem("itemData"));

    if (items == null) {
        items = [];
    }

    return {
        query: function() { return items },
        save: function(item) {
            item.id = generateUUID(); 
            items.push(item);
            window.localStorage.setItem("itemData", angular.toJson(items));
            return item;
        },
        get: function(options) {
            for (var i = 0; i < items.length; i++) {
                if (options.id === items[i].id) {
                    return items[i];
                }
            }
            return {};
        },
        delete: function(item) {
            for (var i = 0; i < items.length; i++) {
                if (item.id == items[i].id) {
                    items.splice(i, 1);
                    break;
                }
            }
        }
    }
});



//================

function generateUUID() {
    var d = new Date().getTime();
    var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = (d + Math.random()*16)%16 | 0;
        d = Math.floor(d/16);
        return (c=='x' ? r : (r&0x7|0x8)).toString(16);
    });
    return uuid;
};
